#!/usr/bin/python -u

import cgi
import cgitb; cgitb.enable()
import _mssql, sys, locale
from math import ceil
from datetime import date


#ESTE SCRIPT MUESTRA EL INVENTARIO DEL QUE HAY POCAS PIEZAS DE UN LISTADO 
#*******************************************
#************CONSTANTES*********************
#*******************************************

SOLO_EXISTENCIAS=1  # 0 = SE MUESTRAN TODOS LOS ARTICULOS // 1 = SOLO SE MUESTRAN LOS ARTICULOS CON EXISTENCIA
EX_MIN=3



form = cgi.FieldStorage()


if 'PAGE' in form:
    # SE DEFINE LA PAGINA EN BASE AL INDICE:
    # 1 = listado resumen de todas las listas
    # 2 = ver una lista
    # 3 = modificar una lista
    # 4 = modificar un producto
    try:
        PAGE=int(form['PAGE'].value)
    except:
        PAGE=1
else:
    PAGE=1






"""
if 'IVA' in form:
    try:
        IVA=int(form['IVA'].value)
        if not IVA: IVA=0
    except:
        IVA=1
if IVA:
    IVA=1.16
    IVA_si='selected'
else:
    IVA=1
    IVA_no='selected'

if 'SOLO_EXISTENCIAS' in form:
    try:
        SOLO_EXISTENCIAS=int(form['SOLO_EXISTENCIAS'].value)
        if not SOLO_EXISTENCIAS: SOLO_EXISTENCIAS=0
    except:
        SOLO_EXISTENCIAS=1
if SOLO_EXISTENCIAS:
    EXISTENCIAS_si='selected'
else:
    EXISTENCIAS_no='selected'




if 'FACTOR' in form:
    try:
        FACTOR=float(form['FACTOR'].value)
    except:
        FACTOR=1
if 'TC' in form:
    try:
        TC=float(form['TC'].value)
    except:
        TC=14.5

"""

#    /*******************************************/
#    /******SE OBTIENEN DATOS DE OMIKRON*********/
#    /*******************************************/
def get_omikron_data(SOLO_EXISTENCIAS=1):
    lista = '001' #LISTA A UTILIZAR   001=USD 002=MXN
    d = date.today()
    periodo=d.year

    db_conn = _mssql.connect("192.168.0.254","disa_store","bulgaria132")
    db_conn.select_db('omikron_disa')
    if SOLO_EXISTENCIAS:
        #**SOLO ARTICULOS CON EXISTENCIA
        consulta= "SELECT LISTAS.ARTICULO, LISTAS.LISTA, LISTAS.PRECIO, LISTAS.Over_price, LISTAS.Over_quantity_min, ARTICULO.DESCRIP, ARTICULO.EX_REAL, ARTICULO.MARCA, EXISTEN.ARTICULO, EXISTEN.ALMACEN, EXISTEN.EX_REAL, MARCAS.MARCA, MARCAS.DESCRIP, EXISTEN.PERIODO FROM LISTAS, ARTICULO,EXISTEN, MARCAS WHERE ARTICULO.CLAVE = LISTAS.ARTICULO AND ARTICULO.EX_REAL > 0 AND LISTAS.LISTA = %s AND ARTICULO.CLAVE = EXISTEN.ARTICULO AND EXISTEN.ALMACEN='001' AND EXISTEN.EX_REAL > 0 AND MARCAS.MARCA = ARTICULO.MARCA AND EXISTEN.PERIODO= %s ORDER BY ARTICULO.CLAVE ASC"%(lista,periodo)
    else:
        #**ARTICULOS CON EXISTENCIA Y SIN EXISTENCIA
        consulta= "SELECT LISTAS.ARTICULO, LISTAS.LISTA, LISTAS.PRECIO, LISTAS.Over_price, LISTAS.Over_quantity_min, ARTICULO.DESCRIP, ARTICULO.EX_REAL, ARTICULO.MARCA, EXISTEN.ARTICULO, EXISTEN.ALMACEN, EXISTEN.EX_REAL, MARCAS.MARCA, MARCAS.DESCRIP, EXISTEN.PERIODO  FROM LISTAS, ARTICULO,EXISTEN, MARCAS WHERE ARTICULO.CLAVE = LISTAS.ARTICULO AND LISTAS.LISTA = %s AND ARTICULO.CLAVE = EXISTEN.ARTICULO AND EXISTEN.ALMACEN='001' AND MARCAS.MARCA = ARTICULO.MARCA AND EXISTEN.PERIODO= %s ORDER BY ARTICULO.CLAVE ASC"%(lista,periodo)
    db_conn.query(consulta)
    res=db_conn.fetch_array()
    db_conn.close()
    omik={}
    for row in res[0][2]:
        if row[1] == lista:
            row_modelo=row[0].strip()
            row_modelo2,row_lista,row_precio, row_oferta, row_oferta_min, row_descrip, row_existencia, row_marca, row_articulo, row_almacen,row_ex_real, row_marcaclave, row_marcadesc, row_periodo=row
            row_precio=float(row_precio)
            if not row_descrip:
                row_descrip=""
            else:
                row_descrip=row_descrip.strip()
            row_ex_real=int(row_ex_real)
            locale.setlocale( locale.LC_ALL, 'en_US.UTF-8' )
            row_precio=float(round(((row_precio*TC*IVA)/FACTOR),2))
            row_precio2=locale.currency(row_precio, grouping=True)
            if not row_oferta: 
                row_oferta='0'
                row_oferta_min='0'
            else:
                row_oferta=float(round(((row_oferta*TC*IVA)/FACTOR),2))
                row_oferta=locale.currency(row_oferta, grouping=True)
                row_oferta_min=int(row_oferta_min)

            omik[row_modelo]=[row_modelo,row_descrip,row_ex_real,row_precio2,row_precio,row_oferta,row_oferta_min,row_marcadesc]
    return omik


#    /******SE OBTIENEN LOS DATOS A REVISAR***********/

def get_listados_data():
    db_conn = _mssql.connect("localhost","avisos","bulgaria132")
    db_conn.select_db('omikron_disa')





#    /*******************************************/
#    /******SE MUESTRAN LOS RESULTADOS***********/
#    /*******************************************/

omikron = get_omikron_data()
revisar = get_listados_data()




buff='Content-Type: text/html\n\n'
buff+='''
<HTML>
<HEAD><TITLE>LISTADO DISA</TITLE></HEAD>
<script type="text/javascript" language="javascript" src="/js/jquery.js"></script> 
<script type="text/javascript" language="javascript" src="/js/jquery.dataTables.js"></script>
<script type="text/javascript" language="javascript" src="/js/jquery.formatCurrency.js"></script>
<script type="text/javascript" language="javascript" src="/js/pyprecios.js"></script>

<style type="text/css" title="currentStyle"> 
@import "/css/pyprecios.css"; 
@import "/css/demo_page.css"; 
@import "/css/demo_table.css"; 
@import "/css/demo_table_jui.css"; 
@import "/css/jquery.dataTables.css"; 
@import "/css/jquery.dataTables_themeroller.css"; 
</style>



<script type="text/javascript" charset="utf-8"> 
$(document).ready(function() {
$('#tabla_productos').dataTable({

"aLengthMenu": [[10, 25, 50, -1], [10, 25, 50, "All"]]
});
} );
</script>

<BODY>
<H1>LISTADO DE PRODUCTOS</H1>
<div id="opciones"><H2>OPCIONES:</H2>
   <form method="post">
     <div class="opcion">IVA:
       <select name="IVA">
         <option value="1" %s>S&iacute;</option>
         <option value="0" %s>No</option>
       </select>
     </div>
     <div class="opcion">SOLO EXISTENCIAS:
       <select name="SOLO_EXISTENCIAS">
         <option value="1" %s>S&iacute;</option>
         <option value="0" %s>No</option>
       </select>
     </div>
     <div class="opcion">TC:<input type="text" name="TC" value="%s"></input></div>
     <div class="opcion">Factor:<input type="text" name="FACTOR" value="%s"></input></div>
     <div class="opcion"><input type="submit" value="Aplicar" /></div>
   </form>
</div>

<form action="">
<TABLE id="tabla_productos">
<THEAD><TR>
<!--TH>COTIZAR</TH>
<TH>COTIZAR</TH-->
<TH>MODELO</TH>
<TH>MARCA</TH>
<TH>DESCRIPCION</TH>
<TH>EXISTENCIA</TH>
<TH>PRECIO</TH>
<TH>OFERTA</TH>
<TH>M&Iacute;NIMO</TH>
</TR></THEAD>'''%(IVA_si,IVA_no,EXISTENCIAS_si,EXISTENCIAS_no,TC,FACTOR)

buff+='\n<TBODY>\n\n'
for i in omik: 
    buff+='<TR>'
    buff+='<!--TD><input type="checkbox" id="%s" class="suma_articulos" value="%.2f"></TD>'%(omik[i][0],omik[i][4])
    buff+='<TD><div id="in_%s" class="suma-articulos-cantidad">0</div>'%omik[i][0]
    buff+='<div class="sum" id="mas_%s">+</div><div class="res" id="res_%s">-</div></TD-->'%(omik[i][0],omik[i][0])
    buff+='<TD>%s</TD>'%omik[i][0]
    buff+='<TD>%s</TD>'%omik[i][7]
    buff+='<TD>%s</TD>'%omik[i][1]
    buff+='<TD>%i</TD>'%omik[i][2]
    buff+='<TD>%s</TD>'%omik[i][3]
    buff+='<TD>%s</TD>'%omik[i][5]
    buff+='<TD>%s</TD>'%omik[i][6]
    buff+='</TR>\n'
buff+='</TBODY>\n'
buff+='</TABLE>\n'
buff+='</form>\n'
buff+='<!--div id="resultado_suma_p">Total: <div id="resultado_suma" value="0.0">$0.00</div>\n'
buff+='<div id="btn_limpiar"><input id="limpiar" type="submit" value="limpiar"></div-->\n'
buff+='</BODY>\n'
buff+='</HTML>'

print buff
